#include <iostream>
#include <vector>
#include <SFML/Graphics.hpp>
#include "raumschiff.h"
#include "asteroid.h"
#include "bullet.h"
#include "kollision.h"
 
using namespace sf;
 
int main()
{
	RenderWindow window(VideoMode(800, 600), "Unser erstes SFML Projekt");
	Clock clock;
	Font font;
	Kollision kollision;
	Texture BGTexture;
	Sprite BGSprite;
 
	std::vector<Asteroid> astros;
	std::vector<Bullet> bullets;
	std::vector<BUllet>::iterator it;
 
	BGTexture.loadFromFile("background.png");
	BGSprite.setTexture(BGTexture);
	BGSprite.SetPosition(0,0);
	Raumschiff Schiff("raumschiff.png");
 
	int timecount = 0; 
	int random_x = 0;
 
	while(window.isOpen())
	{
		Event event;
 
		float ElapsedTime = clock.restart().asMilliseconds();
		timecount += ElapsedTime;
 
		while(window.pollEvent(event))
		{
			if(event.type == Event::Closed)
				window.close();
		}
 
		// Asteroiden Erstellung
		if(timecount >= 100)
		{
			random_x = (rand()%700)+1;
 
			Asteroid astro = Asteroid("asteroid.png");
			astro.SetPosition(random_x, -20);
			astros.push_back(astro);
 
			timecount = 0;
		}
 
		// schuesse erzeugen
		if(Keyboard::isKeyPressed(Keyboard::Space))
		{
			Bullet bull = Bullet("bullet.png");
			bull.SetPosition(Schiff.getPosition().x - 5, Schiff.getPosition().y);
			bullets.push_back(bull);
 
		}
 
		window.clear(Color(0,100,255));
		window.draw(BGSprite);
 
		for (int i = 0; i < astros.size(); i++)
		{
			if(astros[i].Active)
			{
				astros[i].Update(window, ElapsedTime);
				astros[i].Render(window);
			} else {
				astros.erase(astros.begin()+i);
			}			
		}
 
		// schuesse darstellen
		for(it = bullets.begin(); it != bullets.end(); )
		{
			if(!it->Active)
			{
				it = bullets.erase(it);
			} else {
				kollision.box2box(it->BulletSprite, astros);
				it->Update(window, ElapsedTime);
				it->Render(window);
				++it;
			}
		}
 
		Schiff.Update(window, ElapsedTime);
		Schiff.Render(window);
 
		window.display();
	}
 
	return 0;
}