#include "asteroid.h"
 
Asteroid::Asteroid(sf::String tex)
{
	Speed = .5f;
	Active = true;
 
	if(!Texture.loadFromFile(tex))
	{
		std::cout << "Bilddatei konnte nicht gefunden werden." << std::endl;
	} else {
		std::cout << "asteroid.png wurde erfolgreich geladen." << std::endl;
	}
 
	Textur.setSmooth(false);
	AsteroidSprite.setTexture(Textur);
	AsteroidSprite.setOrigin(35.f, 35.f);
	AsteroidSprite.setPosition(160.f, 120.f);
	AsteroidSprite.setRotation(180.f);
}
 
void Asteroid::Update(RenderWindow &Window, float ElapsedTime)
{
	if(!Active)
	{
		float x = AsteroidSprite.getPosition().x;
		float y = AsteroidSprite.getPosition().y;
 
		if (y <= Window.getSize().y)
		{
			y += Speed*ElapsedTime;
		} else {
			Active = false;
		}
 
		AsteroidSprite.setPosition(x,y);
	}
}
 
void Asteroid::Render(sf::RenderWindow &Window)
{
	if(Active)
	{
		Window.draw(AsteroidSprite);
	}
}